/// <reference types="node" />
import { ChildProcess } from 'child_process';
export interface ContextConfig {
    rootPath: string;
    buildDir?: string;
    webpackConfigPath?: string;
}
export declare class TaskContext {
    private childProcesses;
    private teardowns;
    private commands;
    readonly config: ContextConfig;
    registerCommand: (command: string, contextCommand: {
        handler: (args?: {
            [arg: string]: string | boolean;
        }) => void;
        description: string;
        options?: string[];
    }) => void;
    constructor(config: ContextConfig);
    registerChildProcess(child: ChildProcess, options?: {
        silent?: boolean;
    }): void;
    onExit(cb: () => void): void;
    private exit();
    private exitGracefully();
}
