"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_decorators_1 = require("core-decorators");
const gulp = require("gulp");
const ts = require("gulp-typescript");
const sourcemaps = require("gulp-sourcemaps");
const taskGroup_1 = require("../taskGroup");
let ServerCompiler = class ServerCompiler extends taskGroup_1.TaskGroup {
    compile() {
        const { rootPath, buildDir } = this.context.config;
        const project = this.tsProject || (this.tsProject =
            ts.createProject(`${rootPath}/src/server/tsconfig.json`));
        return gulp.src(`${rootPath}/src/server/**/*.ts`)
            .pipe(sourcemaps.init())
            .pipe(project())
            .pipe(sourcemaps.write('.', {
            includeContent: false,
            sourceRoot: './'
        }))
            .pipe(gulp.dest(`${rootPath}/${buildDir}/server`));
    }
    watch(done) {
        const { onExit, config: { rootPath } } = this.context;
        this.watcher = gulp.watch(`${rootPath}/src/server/**/*`, this.recompile);
        onExit(this.closeWatcher);
        done();
    }
    recompile() {
        process.stdout.write('recompiling server...\n');
        return this.compile();
    }
    closeWatcher() {
        if (this.watcher) {
            process.stdout.write('closing server file watcher\n');
            this.watcher.close();
            this.watcher = null;
        }
    }
};
ServerCompiler = __decorate([
    core_decorators_1.autobind
], ServerCompiler);
exports.ServerCompiler = ServerCompiler;
