"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_decorators_1 = require("core-decorators");
const nodemon = require("gulp-nodemon");
const taskGroup_1 = require("../taskGroup");
let Server = class Server extends taskGroup_1.TaskGroup {
    constructor() {
        super(...arguments);
        this.serving = false;
    }
    get running() {
        return this.serving;
    }
    serve(done) {
        const { onExit, config: { rootPath, buildDir } } = this.context;
        // hackaround for nodemon stream not signaling done-ness to the gulp task
        onExit(done);
        return nodemon({
            script: `${rootPath}/${buildDir}/server`,
            ext: 'js json',
            env: Object.assign({}, process.env),
            watch: [
                `${rootPath}/${buildDir}/server`,
                `${rootPath}/${buildDir}/common`
            ],
            nodeArgs: ['--trace-warnings', '-r', 'source-map-support/register'],
            stdout: false
        })
            .on('start', () => this.serving = true)
            .on('end', () => this.serving = false)
            .on('crash', () => this.serving = false)
            .on('stdout', (message) => process.stdout.write(`[dev] ${message}`))
            .on('stderr', (err) => process.stderr.write(`[dev] ${err}`));
    }
};
Server = __decorate([
    core_decorators_1.autobind
], Server);
exports.Server = Server;
