"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_decorators_1 = require("core-decorators");
const gulp = require("gulp");
const gulp_tslint_1 = require("gulp-tslint");
const tslint = require("tslint");
const taskGroup_1 = require("../taskGroup");
const formatter = 'stylish';
let TsLinter = class TsLinter extends taskGroup_1.TaskGroup {
    lintTasks() {
        const { rootPath } = this.context.config;
        const program = this.taskProgram || (this.taskProgram =
            tslint.Linter.createProgram(`${rootPath}/gulp/tsconfig.json`));
        return gulp.src(`${rootPath}/gulp/**/*.ts`)
            .pipe(gulp_tslint_1.default({ formatter, program }))
            .pipe(gulp_tslint_1.default.report());
    }
    lintServer() {
        const { rootPath } = this.context.config;
        const program = this.serverProgram || (this.serverProgram =
            tslint.Linter.createProgram(`${rootPath}/src/server/tsconfig.json`));
        return gulp.src(`${rootPath}/src/server/**/*.ts`)
            .pipe(gulp_tslint_1.default({ formatter, program }))
            .pipe(gulp_tslint_1.default.report());
    }
    lintClient() {
        const { rootPath } = this.context.config;
        const program = this.clientProgram || (this.clientProgram =
            tslint.Linter.createProgram(`${rootPath}/src/client/tsconfig.json`));
        return gulp.src(`${rootPath}/src/client/**/*.ts{x}`)
            .pipe(gulp_tslint_1.default({ formatter, program }))
            .pipe(gulp_tslint_1.default.report());
    }
};
TsLinter = __decorate([
    core_decorators_1.autobind
], TsLinter);
exports.TsLinter = TsLinter;
